/**
 * 
 */
package testLab;

import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.io.PrintStream;

import javax.imageio.ImageIO;

/**
 * @author Wekabu
 * 
 */
public class Transperency {

	public static final int MAXWIDTH = 7; // Change this Value according to the newest Runtime
	
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		
		File imageFile = new File("image.png");
		File out = new File("out.json");
		
		BufferedImage img = ImageIO.read(imageFile);
		
		PrintStream outStream = new PrintStream(out);
		System.setOut(outStream);
		
		int xntStart = 0;
		boolean setNoComma = true;
		System.out.println("[ \n"
				+ " { \n"
				+ "  \"animation\": [ \n");
		
		
		
		for (int y = 0; y < img.getHeight(); y++) 
		{
			xntStart = -1;
			
			for (int x = 0; x < img.getWidth(); x ++) 
			{
				if (img.getRGB(x, y) == 0 || img.getRGB(x, y) == 16777215) 
				{

					//pixel transparent
					if (xntStart != -1) 
					{
						if (!setNoComma) 
						{
							System.out.println(",");
						} else 
						{
							setNoComma = false;
						}
		
						System.out.print(String.format("{ \"id\" : \"Wekabu_nightmaker_%d\", \"x\":%d, \"y\": %d  }",
															x - xntStart, xntStart, (int) (y  - img.getHeight()*0.75)));
					
					xntStart = -1;
					}
				}
					else
				{
						//pixel non-transparent
						if (xntStart == -1) 
						{
							xntStart = x;
						} 
						else 
						{
							if (x - xntStart == MAXWIDTH) 
							{
								
								if (!setNoComma) 
								{
									System.out.println(",");
								} else 
								{
									setNoComma = false;
								}
								System.out.print(String.format("{ \"id\" : \"Wekabu_nightmaker_%d\", \"x\":%d, \"y\": %d  }",
																	x - xntStart, xntStart, (int) (y  - img.getHeight()*0.75)));
								xntStart = x;
								
							}
						}
				}
			}
		}

		System.out.println("\n ] \n");
		System.out.println("} \n ]");
		System.out.flush();
		

	}

}
